"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessWorkflowTextEditor = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = require("react");
var react_1 = require("react");
var api_1 = require("@kie-tools-core/workspace/dist/api");
var SwfTextEditorController_1 = require("./textEditor/SwfTextEditorController");
var SwfTextEditor_1 = require("./textEditor/SwfTextEditor");
var api_2 = require("@kie-tools-core/editor/dist/api");
var RefForwardingServerlessWorkflowTextEditor = function (props, forwardedRef) {
    var _a = __read((0, react_1.useState)(undefined), 2), initialContent = _a[0], setInitialContent = _a[1];
    var swfTextEditorRef = (0, react_1.useRef)(null);
    (0, react_1.useImperativeHandle)(forwardedRef, function () {
        return {
            setContent: function (path, newContent) {
                try {
                    setInitialContent({
                        originalContent: newContent,
                        path: path,
                    });
                    return Promise.resolve();
                }
                catch (e) {
                    console.error(e);
                    return Promise.reject();
                }
            },
            getContent: function () {
                var _a;
                return Promise.resolve(((_a = swfTextEditorRef.current) === null || _a === void 0 ? void 0 : _a.getContent()) || "");
            },
            getPreview: function () {
                return Promise.resolve("");
            },
            undo: function () {
                var _a;
                props.onStateControlCommandUpdate(api_2.StateControlCommand.UNDO);
                return ((_a = swfTextEditorRef.current) === null || _a === void 0 ? void 0 : _a.undo()) || Promise.resolve();
            },
            redo: function () {
                var _a;
                props.onStateControlCommandUpdate(api_2.StateControlCommand.REDO);
                return ((_a = swfTextEditorRef.current) === null || _a === void 0 ? void 0 : _a.redo()) || Promise.resolve();
            },
            validate: function () {
                return Promise.resolve([]);
            },
            setTheme: function (theme) {
                var _a;
                return ((_a = swfTextEditorRef.current) === null || _a === void 0 ? void 0 : _a.setTheme(theme)) || Promise.resolve();
            },
        };
    }, [props]);
    var setValidationErrors = (0, react_1.useCallback)(function (errors) {
        if (!initialContent) {
            return;
        }
        var notifications = errors.map(function (error) { return ({
            type: "PROBLEM",
            path: initialContent.path,
            severity: "ERROR",
            message: "".concat(error.message),
            position: {
                startLineNumber: error.startLineNumber,
                startColumn: error.startColumn,
                endLineNumber: error.endLineNumber,
                endColumn: error.endColumn,
            },
        }); });
        props.setNotifications.apply(initialContent.path, notifications);
    }, [initialContent, props.setNotifications]);
    var isVscode = (0, react_1.useCallback)(function () {
        return props.channelType === api_2.ChannelType.VSCODE_DESKTOP || props.channelType === api_2.ChannelType.VSCODE_WEB;
    }, [props.channelType]);
    var onContentChanged = (0, react_1.useCallback)(function (newContent, operation) {
        var _a, _b;
        switch (operation) {
            case SwfTextEditorController_1.SwfTextEditorOperation.EDIT:
                props.onNewEdit(new api_1.WorkspaceEdit(newContent));
                break;
            case SwfTextEditorController_1.SwfTextEditorOperation.UNDO:
                if (!isVscode()) {
                    (_a = swfTextEditorRef.current) === null || _a === void 0 ? void 0 : _a.undo();
                }
                props.onStateControlCommandUpdate(api_2.StateControlCommand.UNDO);
                break;
            case SwfTextEditorController_1.SwfTextEditorOperation.REDO:
                if (!isVscode()) {
                    (_b = swfTextEditorRef.current) === null || _b === void 0 ? void 0 : _b.redo();
                }
                props.onStateControlCommandUpdate(api_2.StateControlCommand.REDO);
                break;
        }
    }, [props, isVscode]);
    return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: initialContent && ((0, jsx_runtime_1.jsx)(SwfTextEditor_1.SwfTextEditor, { channelType: props.channelType, content: initialContent.originalContent, fileName: initialContent.path, onContentChange: onContentChanged, setValidationErrors: setValidationErrors, ref: swfTextEditorRef, isReadOnly: props.isReadOnly }, void 0)) }, void 0));
};
exports.ServerlessWorkflowTextEditor = React.forwardRef(RefForwardingServerlessWorkflowTextEditor);
//# sourceMappingURL=ServerlessWorkflowTextEditor.js.map